﻿using System;

using Android.App;
using Android.Content.PM;
using Android.OS;
using Com.Syncfusion.Charts;
using Android.Graphics;
using Android.Views;

namespace GradientColor.Droid
{
    [Activity(Label = "GradientColor", Icon = "@drawable/icon", MainLauncher = true, ConfigurationChanges = ConfigChanges.ScreenSize | ConfigChanges.Orientation)]
    public class MainActivity : global::Xamarin.Forms.Platform.Android.FormsApplicationActivity
    {
        protected override void OnCreate(Bundle bundle)
        {
            base.OnCreate(bundle);
            Xamarin.Forms.Forms.ViewInitialized += Forms_ViewInitialized;
            global::Xamarin.Forms.Forms.Init(this, bundle);
            LoadApplication(new App());
        }
        private void Forms_ViewInitialized(object sender, Xamarin.Forms.ViewInitializedEventArgs e)
        {
            SfChart nativeChart = e.NativeView as SfChart;
            
            if (nativeChart is SfChart)
            {
                for (int i = 0; i < (nativeChart.SecondaryAxis as NumericalAxis).StripLines.Size(); i++)
                {
                    ((nativeChart.SecondaryAxis as NumericalAxis).StripLines.Get(i) as NumericalStripLine).StrokePathEffect = new DashPathEffect(new float[] { 10, 20 }, 0);
                }

                SplineAreaExt SplineAreaSeriesExt = new SplineAreaExt();

                for (int i = 0; i < (e.NativeView as SfChart).Series.Size(); i++)
                {

                    SplineAreaSeriesExt.DataSource = ((SplineAreaSeries)(nativeChart.Series.Get(i))).DataSource;
                    nativeChart.Series.Remove(i);
                }
                
                (e.NativeView as SfChart).Series.Add(SplineAreaSeriesExt);
            }

            // Bring StripLine to front of the series

            for (int i = 0; i < (e.NativeView as ViewGroup).ChildCount; i++)
            {
                ViewGroup rootLayout = (e.NativeView as ViewGroup).GetChildAt(i) as ViewGroup;

                if (rootLayout is ChartRootLayout)
                {
                    for (int j = 0; j < rootLayout.ChildCount; j++)
                    {
                        if (rootLayout.GetChildAt(j) is ChartAreaLayout)
                        {
                            for (int k = 0; k < (rootLayout.GetChildAt(j) as ViewGroup).ChildCount; k++)
                            {
                                if ((rootLayout.GetChildAt(j) as ViewGroup).GetChildAt(k) is ChartStripLinesRenderer)
                                {
                                    (rootLayout.GetChildAt(j) as ViewGroup).GetChildAt(k).BringToFront();
                                    break;
                                }
                            }
                        }
                    }
                }
            }
        }        
    }

    public class SplineAreaExt : SplineAreaSeries
    {
        protected override ChartSegment CreateSegment()
        {
            return new SplineAreaSegmentExt();
        }
    }

    public class SplineAreaSegmentExt : SplineAreaSegment
    {
        public override void OnDraw(Android.Graphics.Canvas p0)
        {

            this.FillPaint.SetShader(new LinearGradient(0, 0, 0, p0.Height, Android.Graphics.Color.Orange, Android.Graphics.Color.Yellow, Shader.TileMode.Clamp));

            base.OnDraw(p0);
        }
    }
}

