﻿using Syncfusion.SfChart.XForms;
using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using Xamarin.Forms;

namespace GradientColor
{
    public class Sample : ContentPage
    {
        public Sample()
        {
            StackLayout layout = new StackLayout();
            SfChart chart = new SfChart();
            chart.VerticalOptions = LayoutOptions.FillAndExpand;

            DateTimeAxis primaryAxis = new DateTimeAxis();
            primaryAxis.LabelStyle.LabelFormat = "dd/MM";

            NumericalAxis secondaryAxis = new NumericalAxis()
            {
                Minimum = 0,
                Maximum = 50,
                PlotOffset = 10,
            };

            NumericalStripLine dottedStripline = new NumericalStripLine();
            dottedStripline.Start = 40;
            dottedStripline.Width = 0.0001;
            dottedStripline.StrokeWidth = 3;
            dottedStripline.StrokeColor = Color.Red;
            secondaryAxis.StripLines.Add(dottedStripline);

            chart.PrimaryAxis = primaryAxis;
            chart.SecondaryAxis = secondaryAxis;

            ObservableCollection<ChartDataPoint> data = new ObservableCollection<ChartDataPoint>()
            {
                new ChartDataPoint(new DateTime(2016, 1, 1), 10),
                new ChartDataPoint(new DateTime(2016, 1, 2), 25),
                new ChartDataPoint(new DateTime(2016, 1, 3), 7),
                new ChartDataPoint(new DateTime(2016, 1, 4), 18),
                new ChartDataPoint(new DateTime(2016, 1, 5), 42),
                new ChartDataPoint(new DateTime(2016, 1, 6), 17),
                new ChartDataPoint(new DateTime(2016, 1, 6), 22),

            };
            SplineAreaSeries series = new SplineAreaSeries();
            series.ItemsSource = data;
            
            chart.Series.Add(series);
            layout.Children.Add(chart);
            Content = layout;
        }
    }
}